import { __extends } from "tslib";
import { IgrDataLegendSeriesValueInfo } from "./igr-data-legend-series-value-info";
import { DataLegendSummaryColumn as DataLegendSummaryColumn_internal } from "./DataLegendSummaryColumn";
/**
 * Represent a column in summary row
*/
var IgrDataLegendSummaryColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataLegendSummaryColumn, _super);
    function IgrDataLegendSummaryColumn() {
        return _super.call(this) || this;
    }
    IgrDataLegendSummaryColumn.prototype.createImplementation = function () {
        return new DataLegendSummaryColumn_internal();
    };
    Object.defineProperty(IgrDataLegendSummaryColumn.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegendSummaryColumn.prototype, "seriesValues", {
        /**
         * Get values of series in the summary column
        */
        get: function () {
            return this.i.aa;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegendSummaryColumn.prototype, "seriesLabels", {
        /**
         * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
        */
        get: function () {
            return this.i.y;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataLegendSummaryColumn.prototype, "seriesUnits", {
        /**
         * Get optional units on right side of series values, e.g. "Hz" for hertz
        */
        get: function () {
            return this.i.z;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Add a value in the summary column
    
    */
    IgrDataLegendSummaryColumn.prototype.addValue = function (value) {
        this.i.ai(value);
    };
    /**
     * Add label in the summary column
    
    */
    IgrDataLegendSummaryColumn.prototype.addLabel = function (label) {
        this.i.ag(label);
    };
    /**
     * Add unit in the summary column
    
    */
    IgrDataLegendSummaryColumn.prototype.addUnits = function (units) {
        this.i.ah(units);
    };
    return IgrDataLegendSummaryColumn;
}(IgrDataLegendSeriesValueInfo));
export { IgrDataLegendSummaryColumn };
