import { Base, Type } from "./type";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { CodeGeneratingCodeWriter } from "./CodeGeneratingCodeWriter";
import { CodeGenerationItemBuilderPropertyInfo } from "./CodeGenerationItemBuilderPropertyInfo";
import { CodeGenerationRendererOptions } from "./CodeGenerationRendererOptions";
import { List$1 } from "./List$1";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { DescriptionRef } from "./DescriptionRef";
import { StringBuilder } from "./StringBuilder";
import { CodeGeneratingImportManager } from "./CodeGeneratingImportManager";
import { CodeGeneratingComponentRendererDataEmitter } from "./CodeGeneratingComponentRendererDataEmitter";
import { CodeGeneratingComponentRendererDataEmitterPropertyType } from "./CodeGeneratingComponentRendererDataEmitterPropertyType";
import { CodeGeneratingComponentRendererDataEmitterItemType } from "./CodeGeneratingComponentRendererDataEmitterItemType";
import { CodeGenerationLibraryItemContentLocation } from "./CodeGenerationLibraryItemContentLocation";
import { CodeGenerationLibraryItemContent } from "./CodeGenerationLibraryItemContent";
import { JsonDictionaryValue } from "./JsonDictionaryValue";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { CodeGenerationTargetPlatforms } from "./CodeGenerationTargetPlatforms";
import { ComponentRenderer } from "./ComponentRenderer";
import { CodeGeneratingComponentRendererHandlerEmitter } from "./CodeGeneratingComponentRendererHandlerEmitter";
import { CodeGeneratingComponentRendererModuleEmitter } from "./CodeGeneratingComponentRendererModuleEmitter";
import { ICodeGenerationRendererTemplate } from "./ICodeGenerationRendererTemplate";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRendererCodeEmitter extends Base {
    static $t: Type;
    private k;
    private i;
    private t;
    protected a8(a: CodeGenerationItemBuilderPropertyInfo): void;
    protected get j(): CodeGeneratingRendererResult;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private d;
    protected get h(): CodeGeneratingCodeWriter;
    private a;
    protected get e(): CodeGeneratingCodeWriter;
    private c;
    protected get g(): CodeGeneratingCodeWriter;
    private b;
    protected get f(): CodeGeneratingCodeWriter;
    private u;
    protected at(a: string): void;
    n(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    p(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    private x;
    protected get ae(): string;
    au(a: string): void;
    a7(): void;
    a2(a: string): void;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    toString(): string;
    protected am(): string;
    protected ap(a: CodeGenerationItemBuilderPropertyInfo, b: boolean): string;
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    private ao;
    protected o(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    private ak;
    protected ai(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected al(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected aj(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_r(): boolean;
    protected get r(): boolean;
    protected ac(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ab(a: any): string;
    protected aa(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected z(a: any): string;
    private v;
    private w;
    a6(a: string): void;
    a5(a: string): void;
    private ag;
    a3(): void;
    protected get_ar(): string;
    protected get ar(): string;
    get ad(): string;
    protected get q(): boolean;
    protected get l(): boolean;
    protected get m(): boolean;
    aq: string;
    protected get_s(): boolean;
    get s(): boolean;
    a4(): void;
    aw(a: StringBuilder): void;
    az(a: StringBuilder): void;
    av(a: StringBuilder): void;
    ax(a: CodeGeneratingImportManager): void;
    protected ay(a: List$1<string>, b: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class BlazorRazorCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_s(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected bc(a: string, b: CodeGenerationItemBuilderPropertyInfo): string;
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    au(a: string): void;
    a7(): void;
    a2(a: string): void;
    private bb;
    private a9;
    private ba;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ai(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ap(a: CodeGenerationItemBuilderPropertyInfo, b: boolean): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected am(): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    private bd;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_ar(): string;
}
/**
 * @hidden
 */
export declare class BlazorCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_s(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_r(): boolean;
    protected get_ar(): string;
    private a9;
    private ba;
    au(a: string): void;
    private bc;
    a7(): void;
    private bb;
    protected aj(a: CodeGenerationItemBuilderPropertyInfo): string;
    a2(a: string): void;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected am(): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected ay(a: List$1<string>, b: CodeGeneratingImportManager): void;
}
/**
 * @hidden
 */
export declare class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_r(): boolean;
    au(a: string): void;
    private bc;
    a7(): void;
    a2(a: string): void;
    private bb;
    private a9;
    private ba;
    protected get_ar(): string;
    protected ay(a: List$1<string>, b: CodeGeneratingImportManager): void;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected am(): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected aj(a: CodeGenerationItemBuilderPropertyInfo): string;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected v(a: string, b?: boolean): string;
    protected u(a: string): string;
    protected ao(a: string): string;
    protected get_s(): string;
    private ak;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingImportManager): void;
    protected af(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ag(a: string, b: JsonDictionaryValue): void;
    protected ah(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected x(a: string, b: CodeGeneratingImportManager): void;
    protected y(a: string, b: CodeGeneratingImportManager): void;
    protected z(a: string, b: CodeGeneratingImportManager): void;
    protected ab(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private al;
    private an;
    protected ai(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected w(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private ap;
    protected t(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected am(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_r(): boolean;
    protected get_ar(): string;
    private bb;
    private a9;
    private ba;
    au(a: string): void;
    protected ay(a: List$1<string>, b: CodeGeneratingImportManager): void;
    private bc;
    a7(): void;
    a2(a: string): void;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected aj(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected am(): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected z(a: string, b: CodeGeneratingImportManager): void;
    protected ad(a: CodeGeneratingCodeWriter): void;
    private ak;
    protected ac(a: CodeGeneratingCodeWriter): void;
    protected v(a: string, b?: boolean): string;
    protected u(a: string): string;
    protected ao(a: string): string;
    protected aj(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingImportManager): void;
    protected af(a: string, b: CodeGenerationLibraryItemContentLocation, c: CodeGenerationLibraryItemContent): void;
    protected ag(a: string, b: JsonDictionaryValue): void;
    protected ah(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected get_s(): string;
    protected ab(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingImportManager): void;
    private al;
    private an;
    protected ai(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected w(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private ap;
    protected t(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected am(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_s(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected af(a: CodeGenerationItemBuilderPropertyInfo): string;
    au(a: string): void;
    a7(): void;
    a2(a: string): void;
    a0(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected am(): string;
    protected ah(a: CodeGenerationItemBuilderPropertyInfo): string;
    private a9;
    protected an(a: CodeGenerationItemBuilderPropertyInfo): string;
    a1(a: number, b: string, c: CodeGenerationItemBuilderPropertyInfo, d: TypeDescriptionContext): void;
    protected get_ar(): string;
}
/**
 * @hidden
 */
export declare class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    protected get_s(): boolean;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRenderer extends ComponentRenderer {
    static $t: Type;
    loadCodeJson(a: string): void;
    static dp(a: string): string;
    static dq(a: string): string;
    static dr(a: string): string;
    protected ak(): boolean;
    z(a: JsonDictionaryItem): boolean;
    ae(a: JsonDictionaryItem): boolean;
    aa(a: JsonDictionaryItem): boolean;
    dd(a: CodeGenerationItemBuilder, b: CodeGenerationRendererOptions, c: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    de(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererDataEmitter;
    df(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererHandlerEmitter;
    dg(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererModuleEmitter;
    emitCode(a: ICodeGenerationRendererTemplate): CodeGeneratingRendererResult;
    private dv;
    protected a4(): (arg1: string) => string;
    private ds;
    private dt;
    private di;
    private dj;
    private dk;
    private dl;
    private dm;
    constructor(a: CodeGenerationTargetPlatforms, b: CodeGenerationRendererOptions);
    private static dn;
}
/**
 * @hidden
 */
export declare class CodeGenerationContainer extends Base {
    static $t: Type;
    private _id;
    get id(): string;
    set id(a: string);
    constructor();
    a: List$1<CodeGenerationItemBuilder>;
    c(a: CodeGeneratingRendererResult, b: CodeGeneratingComponentRenderer, c: CodeGenerationRendererOptions): void;
}
/**
 * @hidden
 */
export declare class CodeGenerationItemBuilder extends Base {
    static $t: Type;
    private g;
    private f;
    private c;
    private b;
    private j;
    private h;
    constructor(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: any);
    a(a: string): CodeGenerationItemBuilder;
    private o;
    s(a: string, b: TypeDescriptionMetadata, c: any, d: DescriptionRef): void;
    q(a: string, b: TypeDescriptionMetadata, c: DescriptionRef): void;
    r(a: string, b: TypeDescriptionMetadata): void;
    i(a: string): any;
    p(a: CodeGeneratingComponentRendererCodeEmitter, b: boolean): void;
    protected e(a: CodeGeneratingComponentRendererCodeEmitter): boolean;
    private d;
    private m;
    private n;
    protected get_k(): string;
    protected get k(): string;
    protected get_l(): string;
    protected get l(): string;
}
/**
 * @hidden
 */
export declare class CodeGenerationRendererAdapter extends Base implements IComponentRendererAdapter {
    static $t: Type;
    private a;
    private b;
    constructor(a: CodeGenerationTargetPlatforms, b: IComponentRendererAdapter);
    createColorCollection(a: any[]): any;
    createBrushCollection(a: any[]): any;
    createObject(a: string, b: any, c: TypeDescriptionContext): any;
    coerceToEnum(a: string, b: TypeDescriptionContext, c: string): any;
    onUIThread(a: any, b: () => void): void;
    setOrUpdateCollectionOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: TypeDescriptionContext, e: any, f: any): void;
    private c;
    onPendingRef(a: any, b: string, c: TypeDescriptionMetadata, d: DescriptionRef): void;
    setPropertyValue(a: any, b: string, c: TypeDescriptionMetadata, d: any, e: any, f: DescriptionRef): void;
    getPropertyValue(a: any, b: string): any;
    getRootObject(a: any): any;
    clearContainer(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    forPropertyValueItem(a: any, b: string, c: (arg1: any) => void): void;
    clearCollection(a: any, b: string, c: TypeDescriptionMetadata): void;
    addItemToCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    resetPropertyOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: any): void;
    replaceItemInCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    replaceRootItem(a: any, b: string, c: TypeDescriptionContext, d: (arg1: boolean) => void): void;
    removeItemFromCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number): void;
    removeRootItem(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    flushChanges(a: any): void;
}
