import { Type } from "./type";
/**
 * Describes mode for formating time in header of data legend
 */
export declare enum DataLegendHeaderTimeMode {
    /**
     * Specifies automatic time format that defaults to no string
     */
    Auto = 0,
    /**
     * Specifies time as short string in header row of data legend
     */
    ShortStyle = 1,
    /**
     * Specifies time as long string in header row of data legend
     */
    LongStyle = 2,
    /**
     * Specifies time as medium string in header row of data legend
     */
    MediumStyle = 3,
    /**
     * Specifies time as full string in header row of data legend
     */
    FullStyle = 4,
    /**
     * Specifies no time in header row of data legend
     */
    None = 5
}
/**
 * @hidden
 */
export declare let DataLegendHeaderTimeMode_$type: Type;
