import { Type } from "./type";
/**
 * Describes mode for displaying labels before series values in the data legend.
 */
export declare enum DataLegendLabelMode {
    /**
     * Specifies automatic labels based on series type, e.g. "O: H: L: C:" for Financial Series
     */
    Auto = 0,
    /**
     * Specifies always visible labels before series values
     */
    Visible = 1,
    /**
     * Specifies hidden labels before series values
     */
    Hidden = 2
}
/**
 * @hidden
 */
export declare let DataLegendLabelMode_$type: Type;
