import { Type } from "./type";
/**
 * Describes type of summarization to use for the data legend.
 */
export declare enum DataLegendSummaryType {
    /**
     * Specifies automatic summarization
     */
    Auto = 0,
    /**
     * Specifies total of values in summary row
     */
    Total = 1,
    /**
     * Specifies average of values in summary row
     */
    Average = 2,
    /**
     * Specifies minimum of values in summary row
     */
    Min = 3,
    /**
     * Specifies maximum of values in summary row
     */
    Max = 4,
    /**
     * Specifies no summarization
     */
    None = 5
}
/**
 * @hidden
 */
export declare let DataLegendSummaryType_$type: Type;
