import { Type } from "./type";
/**
 * Describes mode for displaying values in the data legend.
 */
export declare enum DataLegendValueMode {
    /**
     * Specifies automatic mode that resolves to best value display mode
     */
    Auto = 0,
    /**
     * Specifies values as decimal number, e.g. 170.25 for 170.25
     */
    Decimal = 1,
    /**
     * Specifies values with currency symbol, e.g. $170.25 for 170.25
     * Note symbol of the currency depends on the ValueFormatCulture prorperty
     */
    Currency = 2
}
/**
 * @hidden
 */
export declare let DataLegendValueMode_$type: Type;
