import { Base, IList, Type } from "./type";
import { IDataSourceLocalDataProvider } from "./IDataSourceLocalDataProvider";
import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceSchemaPropertyType } from "./DataSourceSchemaPropertyType";
import { IDataSourceExecutionContext } from "./IDataSourceExecutionContext";
import { IDataSourceDataProviderUpdateNotifier } from "./IDataSourceDataProviderUpdateNotifier";
import { SortDescriptionCollection } from "./SortDescriptionCollection";
import { FilterExpressionCollection } from "./FilterExpressionCollection";
import { SummaryDescriptionCollection } from "./SummaryDescriptionCollection";
import { DataSourceSummaryScope } from "./DataSourceSummaryScope";
import { DataSourceDataProviderSchemaChangedEventArgs } from "./DataSourceDataProviderSchemaChangedEventArgs";
/**
 * @hidden
 */
export declare class DataSourceLocalDataProvider extends Base implements IDataSourceLocalDataProvider {
    static $t: Type;
    constructor();
    private am;
    private l;
    private k;
    private e;
    private m;
    private d;
    private x;
    private y;
    get dataSource(): any;
    set dataSource(a: any);
    schemaChanged: (sender: any, args: DataSourceDataProviderSchemaChangedEventArgs) => void;
    getItemAtIndex(a: number): any;
    private r;
    private s;
    getItemValue(a: any, b: string): any;
    setItemValue(a: any, b: string, c: any): void;
    removeItem(a: any): void;
    addItem(a: any): void;
    private ae;
    get actualCount(): number;
    private h;
    get actualSchema(): IDataSourceSchema;
    private j;
    private i;
    resolveSchemaPropertyType(a: string): DataSourceSchemaPropertyType;
    al(a: IDataSourceSchema): void;
    private t;
    private ag;
    private af;
    private u;
    private b;
    private static c;
    private z;
    protected ah(a: string, b: any, c: any): void;
    private v;
    protected get w(): IList;
    private p;
    protected ai(a: string, b: any, c: any): void;
    private g;
    get executionContext(): IDataSourceExecutionContext;
    set executionContext(a: IDataSourceExecutionContext);
    protected get q(): boolean;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    private f;
    get updateNotifier(): IDataSourceDataProviderUpdateNotifier;
    set updateNotifier(a: IDataSourceDataProviderUpdateNotifier);
    private o;
    get deferAutoRefresh(): boolean;
    set deferAutoRefresh(a: boolean);
    get isSortingSupported(): boolean;
    get isFilteringSupported(): boolean;
    get sortDescriptions(): SortDescriptionCollection;
    get filterExpressions(): FilterExpressionCollection;
    get summaryDescriptions(): SummaryDescriptionCollection;
    get summaryScope(): DataSourceSummaryScope;
    set summaryScope(a: DataSourceSummaryScope);
    get notifyUsingSourceIndexes(): boolean;
    private a;
    get propertiesRequested(): string[];
    set propertiesRequested(a: string[]);
    get isItemIndexLookupSupported(): boolean;
    get isKeyIndexLookupSupported(): boolean;
    get isGroupingSupported(): boolean;
    get groupDescriptions(): SortDescriptionCollection;
    n: boolean;
    queueAutoRefresh(): void;
    ad(): void;
    aj(): void;
    protected ak(): void;
    flushAutoRefresh(): void;
    refresh(): void;
    indexOfItem(a: any): number;
    indexOfKey(a: any[]): number;
}
