import { Type } from "./type";
/**
 * Describes available positions on the X axis at which the summary tooltip to be displayed.
 */
export declare enum DataTooltipGroupedPositionX {
    /**
     * A position on the X axis is selected automatically.
     */
    Auto = 0,
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    SnapLeft = 1,
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    SnapRight = 2,
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    SnapMiddle = 3,
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    LeftEdgeSnapLeft = 4,
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    LeftEdgeSnapRight = 5,
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    LeftEdgeSnapMiddle = 6,
    /**
     * Aligns the tooltip so that it appears to the left of the horizontal snap point of the current series if applicable.
     */
    RightEdgeSnapLeft = 7,
    /**
     * Aligns the tooltip so that it appears to the right of the horizontal snap point of the current series if applicable.
     */
    RightEdgeSnapRight = 8,
    /**
     * Aligns the tooltip so that it appears at the middle of the horizontal snap point of the current series if applicable.
     */
    RightEdgeSnapMiddle = 9,
    /**
     * Aligns the tooltip so that it appears to the left of the cursor.
     */
    TrackLeft = 10,
    /**
     * Aligns the tooltip so that it appears to the right of the cursor.
     */
    TrackRight = 11,
    /**
     * Aligns the tooltip so that the cursor appears in the center of the tooltip width.
     */
    TrackMiddle = 12,
    /**
     * Aligns the tooltip relative to the left plot area edge.
     */
    PinLeft = 13,
    /**
     * Aligns the tooltip relative to the right plot area edge.
     */
    PinRight = 14,
    /**
     * Aligns the tooltip width center with the width center of the plot area.
     */
    PinMiddle = 15
}
/**
 * @hidden
 */
export declare let DataTooltipGroupedPositionX_$type: Type;
