import { Base, Type } from "./type";
import { NativeUIBuiltInEvents } from "./NativeUIBuiltInEvents";
import { NativeUIBuiltInProperties } from "./NativeUIBuiltInProperties";
import { NativeUIComponentHorizontalAlignment } from "./NativeUIComponentHorizontalAlignment";
import { NativeUIComponentVerticalAlignment } from "./NativeUIComponentVerticalAlignment";
import { NativeUIComponentBuiltInType } from "./NativeUIComponentBuiltInType";
import { Brush } from "./Brush";
import { CornerRadius } from "./CornerRadius";
import { Thickness } from "./Thickness";
import { Transform } from "./Transform";
import { INativeUIElementFactory } from "./INativeUIElementFactory";
import { UIElementPropertyId } from "./UIElementPropertyId";
/**
 * @hidden
 */
export interface INativeUIElementBridge {
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getTargetForBuildInProperty(a: any, b: NativeUIBuiltInProperties): any;
    getTargetForBuildInEvent(a: any, b: NativeUIBuiltInEvents): any;
    getHorizontalAlignment(a: any): NativeUIComponentHorizontalAlignment;
    setHorizontalAlignment(a: any, b: NativeUIComponentHorizontalAlignment): void;
    getVerticalAlignment(a: any): NativeUIComponentVerticalAlignment;
    setVerticalAlignment(a: any, b: NativeUIComponentVerticalAlignment): void;
}
/**
 * @hidden
 */
export declare let INativeUIElementBridge_$type: Type;
/**
 * @hidden
 */
export declare class NativeUIComponent extends Base {
    static $t: Type;
    v: any;
    protected get_c(): NativeUIComponentBuiltInType;
    get c(): NativeUIComponentBuiltInType;
    private static f;
    static y(a: INativeUIElementFactory): void;
    static z(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    static aa(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    b: INativeUIElementBridge;
    u: any;
    protected t(a: UIElementPropertyId): any;
    protected q(a: UIElementPropertyId): any;
    protected af(a: UIElementPropertyId, b: any): void;
    protected o(a: NativeUIBuiltInProperties): any;
    protected ad(a: NativeUIBuiltInProperties, b: any): void;
    protected w(a: NativeUIBuiltInEvents, b: any): void;
    protected x(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected ab(a: NativeUIBuiltInEvents, b: any): void;
    protected ac(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected p(a: any, b: NativeUIBuiltInProperties): any;
    protected ae(a: any, b: NativeUIBuiltInProperties, c: any): void;
    protected s(a: NativeUIBuiltInProperties): any;
    protected r(a: NativeUIBuiltInEvents): any;
    get n(): number;
    set n(a: number);
    get h(): number;
    set h(a: number);
    get j(): number;
    set j(a: number);
    get ah(): Brush;
    set ah(a: Brush);
    get ai(): Brush;
    set ai(a: Brush);
    get ag(): CornerRadius;
    set ag(a: CornerRadius);
    get ao(): Thickness;
    set ao(a: Thickness);
    get aj(): Brush;
    set aj(a: Brush);
    get g(): number;
    set g(a: number);
    get i(): number;
    set i(a: number);
    get m(): number;
    set m(a: number);
    get an(): Thickness;
    set an(a: Thickness);
    get am(): Transform;
    set am(a: Transform);
    get al(): Brush;
    set al(a: Brush);
    get ak(): Brush;
    set ak(a: Brush);
    get l(): number;
    set l(a: number);
    get a(): number[];
    set a(a: number[]);
    get k(): number;
    set k(a: number);
    get d(): NativeUIComponentHorizontalAlignment;
    set d(a: NativeUIComponentHorizontalAlignment);
    get e(): NativeUIComponentVerticalAlignment;
    set e(a: NativeUIComponentVerticalAlignment);
}
